// Simple getopt implementation
// This is missing from Visual C++.
// You'll find a bunch of similar versions scattered around the net.
//
// Copyright (C) David Elworthy 2004
// All rights reserved.
//
// Redistribution and use in source and binary forms for any purpose, with or
// without modification, are permitted provided that the following conditions
// are met:
// 
// 1. Redistributions of source code must retain the above copyright notice,
//    this list of conditions, and the following disclaimer.
// 
// 2. Redistributions in binary form must reproduce the above copyright
//    notice, this list of conditions, and the disclaimer that follows 
//    these conditions in the documentation and/or other materials 
//    provided with the distribution.
//
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
// WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
// MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN
// NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
// SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
// TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
// PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
// LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
// You may contact me at david@friendlymoose.com.

#include "getopt.h"
#include <string.h>

int optind = 1;
char *optarg = NULL;
int opterr = 0;
int optopt = '?';   // Character for unrecognised option

#define EOF (-1)

int local_getopt(int argc, char * const argv[], const char *optstr)
{
    opterr = 0;
    if (optind >= argc)
    {
        return EOF;
    }
    const char *optstrend = optstr + strlen(optstr);
    
    if (argv[optind][0] == '-')
    {
        if (argv[optind][1] == '-') // -- = end of arguments
        {
            opterr = 1;
            optind += 1;
            return EOF;
        }

        char *at = strchr(optstr, argv[optind][1]);
        if (at == NULL)
        {
            // Unknown option: return optopt
            opterr = 1;
            optind += 1;
            return optopt;
        }
        else
        {
            // Known option
            optind += 1;
            if (at < optstrend && at[1] == ':' && optind < argc) // Has argument
            {
                optarg = argv[optind++];
            }
            return *at;
        }
    }
    else
    {
        // No more command line arguments
        opterr = 1;
        optind += 1;
        return EOF;
    }
}
